﻿<UserControl x:Class="AltiumTest.Views.Custom.BinarySelectorUserControl"
             xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
             xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
             xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006" 
             xmlns:d="http://schemas.microsoft.com/expression/blend/2008" 
             xmlns:local="clr-namespace:AltiumTest.Views.Custom"
             mc:Ignorable="d" 
             d:DesignHeight="450" d:DesignWidth="800" x:Name="binContr">
    <UserControl.Resources>
        <local:AlternationIndexToBooleanConverter x:Key="AlternationIndexToBooleanConverter"></local:AlternationIndexToBooleanConverter>
		<local:BinarySelectorWidthConverter x:Key="BinarySelectorWidthConverter"></local:BinarySelectorWidthConverter>
        <Style x:Key="LeftToggleButtonStyle" TargetType="ToggleButton">
            <Setter Property="Background" Value="Transparent" />
            <Setter Property="Template">
                <Setter.Value>
                    <ControlTemplate TargetType="ToggleButton">
                        <Grid>
                            <Border x:Name="border"
            CornerRadius="5,0,0,5" BorderBrush="Black"
            Background="{TemplateBinding Background}" 
            BorderThickness="1,1,0.5,1" 
            >
                                <ContentPresenter 
            HorizontalAlignment="Center" 
            VerticalAlignment="Center" />
                            </Border>
                        </Grid>

                        <ControlTemplate.Triggers>
                            <Trigger Property="IsChecked" Value="True">
                                <Setter 
                                Property="Background"
                                Value="{StaticResource ToggleButtonSelectedBrush}"
                            />
                            </Trigger>
                            <Trigger Property="IsMouseOver" Value="True">
                                <Setter 
                                Property="BorderBrush" TargetName="border"
                                Value="White"
                            />
                                <!--<Setter 
                                Property="BorderThickness" TargetName="border"
                                Value="1,1,1,1"
                            />-->
                            </Trigger>
                        </ControlTemplate.Triggers>
                    </ControlTemplate>
                </Setter.Value>
            </Setter>
        </Style>
        <Style x:Key="RightToggleButtonStyle" TargetType="ToggleButton">
            <Setter Property="Background" Value="Transparent" />
            <Setter Property="Template">
                <Setter.Value>
                    <ControlTemplate TargetType="ToggleButton">
                        <Border x:Name="border"
                            CornerRadius="0,5,5,0" BorderBrush="Black"
                            Background="{TemplateBinding Background}" 
                            BorderThickness="0.5,1,1,1" 
                            Padding="0"
                    >
                            <ContentPresenter 
                            HorizontalAlignment="Center" 
                            VerticalAlignment="Center" 
                        />
                        </Border>
                        <ControlTemplate.Triggers>
                            <Trigger Property="IsChecked" Value="True">
                                <Setter 
                                Property="Background"
                                Value="{StaticResource ToggleButtonSelectedBrush}"
                            />
                            </Trigger>
                            <Trigger Property="IsMouseOver" Value="True">
                                <Setter 
                                Property="BorderBrush" TargetName="border"
                                Value="White"
                            />
                                <!--<Setter 
                                Property="BorderThickness" TargetName="border"
                                Value="1,1,1,1"
                            />-->
                            </Trigger>
                        </ControlTemplate.Triggers>
                    </ControlTemplate>
                </Setter.Value>
            </Setter>
        </Style>
        <Style x:Key="MiddleToggleButtonStyle" TargetType="ToggleButton">
            <Setter Property="Background" Value="Transparent" />
            <Setter Property="Template">
                <Setter.Value>
                    <ControlTemplate TargetType="ToggleButton">
                        <Border x:Name="border"
                            BorderBrush="Black"
                            Background="{TemplateBinding Background}" 
                            BorderThickness="0.5,1,0.5,1" 
                            Padding="0"
                    >
                            <ContentPresenter 
                            HorizontalAlignment="Center" 
                            VerticalAlignment="Center" 
                        />
                        </Border>
                        <ControlTemplate.Triggers>
                            <Trigger Property="IsChecked" Value="True">
                                <Setter 
                                Property="Background"
                                Value="{StaticResource ToggleButtonSelectedBrush}"
                            />
                            </Trigger>
                            <Trigger Property="IsMouseOver" Value="True">
                                <Setter 
                                Property="BorderBrush" TargetName="border"
                                Value="White"
                            />
                                <!--<Setter 
                                Property="BorderThickness" TargetName="border"
                                Value="1,1,1,1"
                            />-->
                            </Trigger>
                        </ControlTemplate.Triggers>
                    </ControlTemplate>
                </Setter.Value>
            </Setter>
        </Style>
    </UserControl.Resources>
    <ItemsControl x:Name="parentIc" ItemsSource="{Binding ElementName=binContr, Path=Source}" AlternationCount="{Binding ElementName=binContr, Path=Source.Count}">
        <ItemsControl.ItemTemplate>
            <DataTemplate>
                <ToggleButton x:Name="tb" Content="{Binding Name}"
                              Style="{StaticResource MiddleToggleButtonStyle}"
                              IsChecked="{Binding IsSelected, Mode=TwoWay}" Command="{Binding ElementName=binContr, Path=ButtonSelectedCommand}"
                              CommandParameter="{Binding}">
					<ToggleButton.Width>
						<MultiBinding Converter="{StaticResource BinarySelectorWidthConverter}">
							<Binding ElementName="parentIc" Path="ActualWidth"/>
							<Binding ElementName="binContr" Path="Source.Count" />
						</MultiBinding>
					</ToggleButton.Width>
                </ToggleButton>
                <DataTemplate.Triggers>

                    <!--Last toggle button-->
                    <DataTrigger Value="True">
                        <DataTrigger.Binding>
                            <MultiBinding Converter="{StaticResource AlternationIndexToBooleanConverter}">
                                <Binding Path="(ItemsControl.AlternationIndex)" RelativeSource="{RelativeSource Self}"/>
                                <Binding ElementName="binContr" Path="Source.Count" />
                            </MultiBinding>
                        </DataTrigger.Binding>
                        <Setter TargetName="tb" Property="Style" Value="{StaticResource RightToggleButtonStyle}"/>
                    </DataTrigger>
                    <!--First toggle button-->
                    <DataTrigger Value="False">
                        <DataTrigger.Binding>
                            <MultiBinding Converter="{StaticResource AlternationIndexToBooleanConverter}">
                                <Binding Path="(ItemsControl.AlternationIndex)" RelativeSource="{RelativeSource Self}"/>
                                <Binding ElementName="binContr" Path="Source.Count" />
                            </MultiBinding>
                        </DataTrigger.Binding>
                        <Setter TargetName="tb" Property="Style" Value="{StaticResource LeftToggleButtonStyle}"/>
                    </DataTrigger>
                </DataTemplate.Triggers>
            </DataTemplate>
        </ItemsControl.ItemTemplate>
        <ItemsControl.ItemsPanel>
            <ItemsPanelTemplate>
                <StackPanel Orientation="Horizontal"/>
            </ItemsPanelTemplate>
        </ItemsControl.ItemsPanel>
    </ItemsControl>
</UserControl>
